<template>
  <div class="layout">
    <div class="drawer-layout">
      <header-component :sidebar="sidebarToggle" @toggle-sidebar="onToggleSidebar" />
      <div class="drawer-content">
        <aside class="sidebar">
          <transition
            name="fade"
            enter-active-class="animated fadeIn"
            leave-active-class="animated fadeOut"
          >
            <div v-if="sidebarToggle" class="backdrop" @click="onToggleSidebar"></div>
          </transition>
          <transition
            appear
            name="sidebar-animation"
            :enter-active-class="`animated ${orientation === Orientation.Portrait ? 'fadeInLeft' : 'fadeInRight'}`"
            :leave-active-class="`animated ${orientation === Orientation.Portrait ? 'fadeOutLeft' : 'fadeOutRight'}`"
          >
            <ul v-if="sidebarToggle" class="sidebar-list">
              <li @click="slideToDownload">Tải game</li>
              <li @click="slideToDrawableImage">Sống dai thành huyền thoại</li>
              <li @click="openMvModal">Official MV</li>
              <li @click="openLegendaryTemplesModal">Ngôi đền huyền thoại</li>
            </ul>
          </transition>
          <div class="layout-content">
            <nuxt />
          </div>
        </aside>
      </div>
    </div>
    <div v-if="modalLoginIsOpen">
      <modal-login-component />
    </div>
    <div v-if="modalMvIsOpen">
      <modal-music-video-component />
    </div>
    <div v-if="modalLegendaryTemplesIsOpen">
      <modal-temple-component />
    </div>
    <!-- <div v-if="modalShareIsOpen">
      <modal-share-component />
    </div>-->
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'nuxt-property-decorator';
import HeaderComponent from '../components/Header.vue';
import { commonModule, SlideName, Orientation } from '../store/common/const';

@Component({
  components: {
    HeaderComponent,
    ModalLoginComponent: () =>
      import(
        /* webpackChunkName: "modal-login" */ '../components/ModalLogin.vue'
      ),
    ModalMusicVideoComponent: () =>
      import(
        /* webpackChunkName: "modal-mv" */ '../components/ModalMusicVideo.vue'
      ),
    ModalTempleComponent: () =>
      import(
        /* webpackChunkName: "modal-temple" */ '../components/ModalLegendaryTemple.vue'
      )
    // ModalShareComponent: () =>
    //   import(
    //     /* webpackChunkName: "modal-share" */ '../components/ModalShare.vue'
    //   )
  }
})
export default class DrawerLayout extends Vue {
  protected sidebarToggle: boolean = false;
  protected sidebarContentToggle: boolean = false;

  protected Orientation = Orientation;

  @commonModule.Action('changeToSlide')
  changeToSlide!: (slide: SlideName) => void;
  @commonModule.Action('toggleMvModal')
  toggleMvModal!: (isOpen: boolean) => void;
  @commonModule.Action('toggleTempleModal')
  toggleTempleModal!: (isOpen: boolean) => void;
  @commonModule.Action('canSwipe')
  protected canSwipe!: (swiped: boolean) => void;

  @commonModule.State('orientation') orientation!: Orientation;
  @commonModule.State('modalLoginIsOpen') modalLoginIsOpen!: boolean;
  @commonModule.State('modalMvIsOpen') modalMvIsOpen!: boolean;
  @commonModule.State('modalLegendaryTemplesIsOpen')
  modalLegendaryTemplesIsOpen!: boolean;
  @commonModule.State('modalShareIsOpen') modalShareIsOpen!: boolean;

  protected onToggleSidebar() {
    this.sidebarToggle = !this.sidebarToggle;
  }

  protected slideToDownload() {
    this.canSwipe(true);
    this.changeToSlide(SlideName.Visual);
    this.sidebarToggle = false;
  }

  protected slideToDrawableImage() {
    this.changeToSlide(SlideName.DrawableImage);
    this.sidebarToggle = false;
  }

  protected openMvModal() {
    this.toggleMvModal(true);
    this.sidebarToggle = false;
  }

  protected openLegendaryTemplesModal() {
    this.toggleTempleModal(true);
    this.sidebarToggle = false;
  }
}
</script>

<style lang="scss" scoped>
.layout {
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  display: flex;
  justify-content: center;
  align-items: center;
  background-color: rgba(0, 0, 0, 0.3);
  height: 100%;
  overflow: hidden;
  margin: 0 auto;
}

.drawer-layout {
  background-color: white;
  overflow: hidden;
  height: 100%;
  width: 100%;
  position: relative;
  display: flex;
  flex-direction: column;

  .drawer-content {
    position: relative;
    height: 100%;

    aside.sidebar {
      position: absolute;
      left: 0;
      top: 0;
      right: 0;
      height: 100%;
      width: 100%;
      display: flex;
      align-items: center;
      justify-content: center;

      &.hide {
        display: none;
      }

      .backdrop {
        position: relative;
        z-index: 99;
        animation-duration: 0.3s;
        background: black;
        background: linear-gradient(
          90deg,
          rgba(0, 0, 0, 0.8) 50%,
          rgba(0, 0, 0, 0) 70%
        );
        width: 100%;
        height: 100%;
      }

      .sidebar-list {
        animation-duration: 0.3s;
        position: absolute;
        top: 6vh;
        left: 0;
        z-index: 999;
        padding: 0;
        margin: 0;
        width: 45%;
        max-width: 400px;
        height: 100%;
        margin-top: 10vh;
        list-style-type: none;
        font-size: 2.5vh;
        padding: 0 5%;

        li {
          text-align: center;
          text-transform: uppercase;
          font-weight: 900;
          font-style: italic;
          color: white;
          text-decoration: none;

          &:hover {
            cursor: pointer;
          }

          &:not(:last-child) {
            &::after {
              content: '';
              display: block;
              width: 100%;
              height: 0.7vh;
              background: url('../assets/img/sidebar_line.png') no-repeat center
                center;
              background-size: contain;
              margin: 2.5vh 0;
            }
          }
        }
      }

      .layout-content {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        z-index: 1;
      }
    }
  }
}

@include Orientation(Landscape) {
  .layout {
    .drawer-layout {
      .drawer-content {
        aside.sidebar {
          .backdrop {
            background: linear-gradient(
              -90deg,
              rgba(0, 0, 0, 0.8) 20%,
              rgba(0, 0, 0, 0) 35%
            );
          }

          .sidebar-list {
            left: initial;
            right: 0;
            width: 20%;
            padding: 0 2%;
          }
        }
      }
    }
  }
}
</style>
